#ifndef __CV_VIDEO_CAP_H__
#define __CV_VIDEO_CAP_H__

#include "node.h"

class CVVideoCapture : public Napi::ObjectWrap<CVVideoCapture> {
  public:
	static Napi::Object Init(Napi::Env env, Napi::Object exports);

	CVVideoCapture(const Napi::CallbackInfo &info);

	Napi::Value Open(const Napi::CallbackInfo &info);
	Napi::Value IsOpened(const Napi::CallbackInfo &info);
	Napi::Value Grab(const Napi::CallbackInfo &info);
	Napi::Value Retrieve(const Napi::CallbackInfo &info);
	Napi::Value Read(const Napi::CallbackInfo &info);
	Napi::Value Set(const Napi::CallbackInfo &info);
	Napi::Value Get(const Napi::CallbackInfo &info);
	Napi::Value GetBackendName(const Napi::CallbackInfo &info);

  private:
	static Napi::FunctionReference *constructor;
	cv::VideoCapture capture_;
};

#endif